#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "stackutil.h"
#include "linkedstack.h"

char* reverseString(char *pSource)
{
	int i = 0;
	int len = 0;

	char *pReturn = NULL;
	LinkedStack *pStack = NULL;
	StackNode *pNode = NULL;

	if( pSource == NULL )
	{
		printf("pSource NULL\n");

		return NULL;
	}

	len = strlen(pSource);
	if( len == 0 )
	{
		printf("ڿ ̰ 0\n");

		return NULL;
	}

	pReturn = (char*)malloc(sizeof(char)*(len+1));
	if( pReturn == NULL )
	{
		printf("reverseString() Error! pReturn Ҵ  \n");

		return NULL;
	}

	pStack = createLinkedStack();
	if(pStack != NULL)
	{
		StackNode node = {0,};

		for(i=0; i<len; i++)
		{
			node.data = pSource[i];
			pushLS(pStack, node);
		}

		for(i=0; i<len; i++)
		{
			pNode = popLS(pStack);
			if( pNode != NULL )
			{
				pReturn[i] = pNode->data;
				free(pNode);
			}
		}
		pReturn[len] = '\0';

		deleteLinkedStack(pStack);
	}
	else
	{
		printf("reverseString() Error! pStack Ҵ  \n");
		
		if(pReturn != NULL)
		{
			free(pReturn);
			pReturn = NULL;
		}		
	}

	return pReturn;
}

int checkBracketMatching(char *pSource)
{
	int i = 0;
	int len = 0;
	int ret = TRUE;
	char buf = 0;
	char popBuf = 0;

	LinkedStack *pStack = NULL;
	StackNode *pNode = NULL;

	if( pSource == NULL )
	{
		ret = TRUE;
		return ret;
	}

	len = strlen(pSource);
	if(len == 0)
	{
		ret = TRUE;
		return ret;
	}

	pStack = createLinkedStack();
	if(pStack != NULL)
	{
		StackNode node = {0,};

		for(i=0; i<len && ret!=FALSE; i++)
		{
			buf = pSource[i];

			switch(buf)
			{
			case '[':
			case '{':
			case '(':
				node.data = buf;
				pushLS(pStack, node);
				break;

			case ']':
			case '}':
			case ')':
				pNode  = popLS(pStack);
				if(pNode == NULL)
				{
					ret = FALSE;
					break;
				}
				else
				{
					popBuf = pNode->data;
					free(pNode);

					if( !(buf==']' && popBuf=='[') &&
						!(buf=='}' && popBuf=='{') &&
						!(buf==')' && popBuf=='(') )
					{
						ret = FALSE;
					}
				}
				break;
			}
		}

		if( isLinkedStackEmpty(pStack) == FALSE )
		{
			ret = FALSE;
		}

		deleteLinkedStack(pStack);
	}
	else
	{
		printf("checkBracketMatching() Error!, pStack Ҵ \n");

		ret = FALSE;
	}

	return ret;
}